% David Ferrone, January 2012

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file produces the primal and dual MRAs.
% To set coefficients, edit BiMRAsetup.m
% This will approximate left boundary and interior functions.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

BiMatper;           

scaling_prim = zeros(n_f,2*n_f); wavelet_prim = zeros(n_f,2*n_f);
scaling_dual = zeros(n_f,2*n_f); wavelet_dual = zeros(n_f,2*n_f);

for k=0:n_f-1
    scaling_prim(k+1,:) = Q_prim(2*k+1,:);      % M
    wavelet_prim(k+1,:) = Q_prim(2*k+2,:);      % N
    scaling_dual(k+1,:) = Q_dual(2*k+1,:);      % \tilde{M}
    wavelet_dual(k+1,:) = Q_dual(2*k+2,:);      % \tilde{N}
end;

x = 0:.001:2*(2*n_s+1);

scaling_prim_fns = zeros(n_f, length(x));
wavelet_prim_fns = zeros(n_f, length(x));
scaling_dual_fns = zeros(n_f, length(x));
wavelet_dual_fns = zeros(n_f, length(x));

[scaling_prim_fns wavelet_prim_fns] = Boundary_Cascade(scaling_prim, wavelet_prim, s_prim, w_prim, n_s, n_f, length(x));
[scaling_dual_fns wavelet_dual_fns] = Boundary_Cascade(scaling_dual, wavelet_dual, s_dual, w_dual, n_s, n_f, length(x));

%wavelet_prim_fns = Boundary_Wavelet(wavelet_prim, scaling_prim_fns, n_s, n_f, length(x));
%wavelet_dual_fns = Boundary_Wavelet(wavelet_dual, scaling_dual_fns, n_s, n_f, length(x));
