% David Ferrone, January 2012

% BiMRA Setup File
% Set your primal (s_prim) and dual (s_dual) scaling coefficients.

% Make sure that S_DUAL CONTAINS MORE non-trivial coefficients,
% s_prim & s_dual are the same (even) length (add 0's to the end of s_prim),
% s_prim & s_dual should be biorthogonal, and should sum to 2.


%s_dual=[0,2,0,0];                    % Primal scaling coefficients
%s_prim=[0,0,1/2,1,1/2,0];                % Dual scaling coefficients

% Splines - an example from Dahmen, Kunoth, and Urban.
%s_prim=[0,0,0,0,.25, .75, .75, .25,0,0,0,0];
%s_dual=[-.01953125,.05859375,.07421875,-.37890625,-.1015625,1.3671875, 1.3671875,-.1015625,-.37890625, .07421875, .05859375,-.01953125];

% Hat function and a dual - an example from Keinert p24
s_prim=[0,0,0,1/2,1,1/2,0,0,0,0];
s_dual=1/64*[3,-6,-16,38,90,38,-16,-6,3,0];

% Daubechies example
%s_prim=1/4*[1+sqrt(3), 3+sqrt(3), 3-sqrt(3), 1-sqrt(3)];
%s_dual=1/4*[1+sqrt(3), 3+sqrt(3), 3-sqrt(3), 1-sqrt(3)];

n_f=11;       % Matrices will be constructed for signals of length 2n_f.
              % n_f >= 2*n_s, where the length of coefficients is 2*n_s+1 (if odd) or 2*n_s+2.
              
BiMRAper