% David Ferrone, January 2012

function p = Cascade(h)
%Input h, a row vector of scaling coefficients.
%Output p, x: p is a matrix containing point values of the N interates,
%x is the interval.

% Cascade returns a matrix p consisting of N sets of point values for iterates of
% the refinement equation. Types are Haar or Hat and refer to the initial
% guess for phi. The input, h, is a row vector of scaling coefficients which sum to 2.

%x is an interval twice the length of the support of phi, in 1/1000
%increments. 

N = 50;      %The number of interations.

%Define the interval x and a 0 matrix p
x=[0:.001:2*(length(h)-1)];
for n=1:N, for k=1:length(x), p(n,k)=0; end; end;

%Define p(1,k) in some appropriate way...

type = 1;     % Initial function: Haar(1) or Hat(2)

if type==1
    for k=1:1000, p(1,k)=1; end;
end;

if type==2
    for k=1:1001, p(1,k)=x(k); end;
    for k=1002:2001, p(1,k)=2-x(k); end;
end;


for n=1:N-1, for k=1:(length(x)-1)/2,
    
        for m=1:length(h), 
            if (2*k-1000*(m-1)-1 >= 1) && (2*k-1000*(m-1)-1 < (length(x)-1)/2)
                p(n+1,k)=p(n+1,k)+h(m)*p(n,2*k-1000*(m-1)-1);
            end;
        end;
    end;
end;

% plots_pref = input('(F)inal result, or (A)ll plots?: ', 's')
% 
% if plots_pref == 'F'
%     plot(x,p(N,:)), axis([0, length(h)-1, min(p(N,:)), max(p(N,:))]);
% end;
% if plots_pref == 'A'
%     %Plot all iterates on one graph
%     plot(x,p), axis([0, length(h)-1, min(p(N,:)), max(p(N,:))]);
% end;

end